from __future__ import division
import sys
sys.path.append('/home/fabee/code/natter')
sys.path.append('/home/fabee/code/')
from natter.Distributions import LpSphericallySymmetric, Truncated, ChiP
from scipy import stats, special
from scipy.special import gamma as G
from scipy.special import gammaln as logG
from fabee import MWJournal
from fabee.Plotting import box_off, disjoint_axes
from numpy import *
from matplotlib.pyplot import *
import mpmath
from natter.Auxiliary import Entropy

def margEntr(n,p):

    term1 = log(p) + logG(n/p) + log(n) - logG(1/p) - logG((n-1)/p) \
            - 2*log(n+p-1)
    term1 = exp(term1)
    term1 *= mpmath.hyper([1 - 1/p, n/p - 1/p + 1, n/p - 1/p + 1], \
                          [n/p - 1/p + 2, n/p - 1/p + 2],1)

    term2 = log(2) + logG(1/p) + logG((n-1)/p) + log(n-1)  - log(p) - logG(n/p) - log(n)

    return term1 + term2



fig = figure(figsize=(10,5))
ax = fig.add_axes([.2,.2,.75,.75])
disjoint_axes(ax)

N = arange(2.,200.)
for p in [ 1, 1.3, 2]:
    MIp = []
    for n in N:
        # create truncated Normal distribution
        h = margEntr(n,p)
        H =  n*logG(1 + 1/p) - logG(1+n/p) + n*log(2)
        MIp.append(h - H/n)
    ax.loglog(N, MIp,'-',label=r'$p=%.1f$' % (p,))
ax.set_xlabel('n',fontsize=16)
ax.set_ylabel('multi-information [nats/dimension]',fontsize=16)
leg = ax.legend(frameon=False)
fig.savefig('MIasFofn.pdf')
